const axios = require('axios');

const authenticate = ({ clientID, clientSecret, entrypoint}) => {

    const credentials = Buffer.from(
        `${clientID}:${clientSecret}`
    ).toString('base64');

    return axios({
        method: 'POST',
        url: `${entrypoint}/authorization-server/oauth/token`,
        headers: {
            Authorization: `Basic ${credentials}`,
            'Content-Type': 'application/x-www-form-urlencoded'
        },
        data: "grant_type=client_credentials"
    });
};

const GNRequest = async (credentials) => {
    const authResponse = await authenticate(credentials);
    const accessToken = authResponse.data?.access_token;

    return axios.create({
        baseURL: `${credentials.entrypoint}`,
        headers: {
            Authorization: `Bearer ${accessToken}`,
            'Content-Type': 'application/json',
            'X-Resource-Token': credentials.PrivateToken
        }
    });
}

module.exports = GNRequest;